<?php
require_once ROOTPATH . 'inc/functions.inc.php';
require_once ROOTPATH . 'inc/db.inc.php';
require_once ROOTPATH . 'inc/form_pro.inc.php';


class Spider
{
    function getLinks($url,$sessId)
    {
        $html = @file_get_contents($url);
        $urlArray = array();
        $temp=getLinkArray($html, $url);
        $urlArray[0] = divideURLCategories($temp,$url);
        $data = array();
        $words = getWords($html);
        $data[] = array($url, $words);
        Spider::storeSpideredLink($url, $words);
		$count=0;
        for ($i = 0; $i < 10; $i++) {
            foreach ($urlArray[$i] as $url) {
                $html = @file_get_contents($url);
                $temp=getLinkArray($html, $url);
        		
                $urls =  divideURLCategories($temp,$url);
                if ($urls !== false) {
                    Spider::mergeLinks($urlArray, $urls, $i + 1);
                }
                $words = getWords($html);
                $data[] = array($url, $words);
                Spider::storeSpideredLink($url, $words);
                $count++;
                Spider::changeSessionInfo($sessId,'linksSpidered',$count);
                
            }
        }
        
        return true;
    }

    function mergeLinks(&$mainLinks, $addLinks, $id)
    {
        global $sess;
        foreach ($addLinks as $link) {
            foreach ($mainLinks as $key) {
                if (in_array($link, $key)) {
                    $exists = true;
                } else {
                    $exists = false;
                }
            }
            if ($exists === false && $link != $sess['url']) {
                $mainLinks[$id][] = $link;
            }
        }
        return true;
    }   
    
    function getSessionInfo($id, $info)
    {
        if (!is_numeric($id))
        {
            return false;
        }
        $db =& new db;
        $sql = "SELECT $info FROM #_sessions WHERE sessionId='$id'";
        $result = $db->getRow($info, 'sessions', $sql);
        if (is_array($result)) {
            return $result;
        }
        return trim($result);
    }

    function getMiscInfo($info,$field,$data,$table)
    {
        $db =& new db;
        $sql = "SELECT $info FROM #_$table WHERE $field='$data'";
        $result = $db->getRow($info, $table, $sql);
        if (is_array($result)) {
            return $result;
        }
        return trim($result);
    }

    function getContentInfo($id, $info)
    {
        if (!is_numeric($id)) {
            return false;
        }
        $db =& new db;
        $sql = "SELECT $info FROM #_content WHERE contentId='$id'";
        $result = $db->getRow($info, 'content', $sql);
        if (is_array($result)) {
            return $result;
        }
        return trim($result);
      }
      
    function changeSessionInfo($id, $info, $data)
    {
        $db =& new db;
        $sql = "UPDATE #_sessions SET $info='$data' WHERE sessionId='$id' LIMIT 1";
        $db->change_db('sessions', $sql);
        return true;
    }
    
    function changeContentInfo($id, $info, $data)
    {
        $db =& new db;
        $sql = "UPDATE #_content SET $info='$data' WHERE contentId='$id' LIMIT 1";
        $db->change_db('content', $sql);
        return true;
    }
    
    
    function getSessionContent($sessionId, $info)
    {
        if (!is_numeric($sessionId)) {
            return false;
        }
        $db =& new db;
        $sql = "SELECT $info FROM #_content WHERE sessionId='$sessionId'";
        $result = $db->getRow($info, 'content', $sql);
        if (is_array($result)) {
            return $result;
        }
        return trim($result);
    }

    function getLatestSession()
    {
        $db =& new db;
        $sql="SELECT * FROM #_sessions WHERE status !='Completed' LIMIT 1";
        $result = $db->getAll('content', $sql);
        if (is_array($result)) {
            return $result;
        }
        return trim($result);
    }

    function addSession($title, $url,$job,$kwds,$sleepSecs)
    {
        $db =& new db;
        $title = mysql_escape_string($title);
          $keywords = explode("\n", $kwds);
   		 foreach ($keywords as $k => $v) {
 	       $keywords[$k] = mysql_escape_string(trim($v));
    	}
    	$dbKeywords=implode(",",$keywords);
    	
        $sql = "INSERT INTO #_sessions (url, title,keywords,sleepSecs,job,status, linksSpidered,sessDateTime) VALUES('$url', '$title','$dbKeywords','$sleepSecs','$job','Pending','0',now())";
        $db->change_db('sessions', $sql);
        return true;
    }
     
      
      
    function storeSpideredLink($url, $content)
    {
	    if (empty($url) || empty($content))
	    {
		    return false;
	    }
        global $sess;
        $sessionId = $sess['sessionId'];
        $db =& new db;
        $sql = "INSERT INTO #_content (sessionId, url, content) VALUES('$sessionId','$url','$content')";
        $db->change_db('content', $sql);
        return true;
    }
  
      
    
    function getContent($html)
    {
        return getWords($html);
    }
    
    
    function makeBloggerPost($sessId,$kwds,$sleepSecs)
{
    $db=&new db;
    $keywords=explode(",",$kwds);
    foreach ($keywords as $k => $v) {
        $keywords[$k] = trim($v);
    }
    $blogId   = trim(Profile::getInfo(1,'blog_id'));
    $blogUser = trim(Profile::getInfo(1,'blog_username'));
    $pass     = trim(Profile::getInfo(1,'blog_password'));
    $blogUrl  = trim(Profile::getInfo(1,'blog_url'));
    $blogName = trim(Profile::getInfo(1,'blog_name'));
    
    $sql = "SELECT contentId FROM #_content WHERE sessionId='$sessId'";
    $ids = $db->get_row('contentId', 'content', $sql);
    
    foreach ($ids as $k => $v) {
        $content[$k] = Spider::getContentInfo($v, 'content');
        $urls[$k] = Spider::getContentInfo($v, 'url');
    }
    
    $count = 0;
    if (count($content) > count($keywords)) {
        $max = count($content);
    } elseif (count($keywords) > count($content)) {
        $max = count($keywords);
    } else {
        $max = count($keywords);
    }
    $k_db  = 0;
    $k_kw = 0;
    for ($x = 0; $x < $max; $x++) {
        
        $k_db++;
        $k_kw++;
        if (count($keywords) <= $k_kw) {
        
            $k_kw = 0;
        } if (count($content) <= $k_db) {
        
            $k_db = 0;
        }
        $entryContent = $content[$k_db];
        $title        = '<a href="'.$urls[$k_db].'">'.$keywords[$k_kw].'</a>';
        $title=htmlspecialchars($title);
       // $title=$keywords[$k2];
        $entryContent = str_replace("<br>", "<br />", $entryContent);
        $entryContent = str_replace("&nbsp;", " ", $entryContent);
        //$entryContent=strip_tags($entryContent);
        //$entryContent=htmlspecialchars($entryContent);
        
     
     
       
        $now = date('Y-m-d').'T'.date('H:i:s').'Z';
       $ret = postToBlogger($blogId, $blogUser, $pass, $blogUrl, $title, $now, $entryContent);
          
        if ($ret == 200) {
            $count = $count + 1;
            doPingOMatic($blogName,$blogUrl);
        }
        
       if ($sleepSecs >=60)
       {
	        sleep($sleepSecs);
       } else {
	       sleep(60);
       }
     

        
    }
    return true;
}

    
    
    
    
    
    
    
}

?>
