<?php

require("functions.php");

set_time_limit(1000);

//$page = "http://www.blogger.com";

$stopwords = array (); //array ('after', 'all', 'also', 'an', 'and', 'are', 'as', 'at', 'be', 'because', 'before', 'between',
            //'but', 'for', 'here', 'however', 'from', 'if', 'in', 'into', 'now', 'of', 'or', 'other',
            //'out', 'our', 'since', 'such', 'then', 'that', 'the', 'these', 'there', 'this',
            //'those', 'to', 'today', 'under', 'upon', 'when', 'where', 'whether', 'which', 'who', 'with',
            //'within', 'without', 'you', 'your');

// Initialize some constants

$master_url_array = array ();

$keyword_array = array ();

// Get the post fields

$spider_url = trim($_POST['url']);
//$spider_url="http://localhost/";
$keyword_content = trim($_POST['keywords']);
$blog_id = trim($_POST['blog_id']);
$blog_username = trim($_POST['blog_username']);
$blog_password = trim($_POST['blog_password']);
$blog_url = trim($_POST['blog_url']);
$blog_name = trim($_POST['blog_name']);

// Get the list of keywords separated and put into an array

$kwds = split("\n", $keyword_content);

foreach ($kwds as $key)
{
        array_push($keyword_array, trim($key));
}

$htmlsrc = getURLContents($spider_url);

$url_array = getLinkArray($htmlsrc);
print_r($url_array);

$result = divideURLCategories($url_array, $spider_url);

foreach ($result as $link)
{
        $meta_url = parse_url($spider_url);
        $murl = explode(".", $meta_url["host"]);

        $pattern = "~^http://\w+\.".$murl[count($murl)-2]."\.".$murl[count($murl)-1].".*~Uis";

        if (preg_match($pattern, $link))
        {
           $master_url_array[] = $link;
        }
}

foreach ($master_url_array as $index=>$link)
{
        $p_src = getURLContents($link);
        $u_array = getLinkArray($p_src);
        $r_array = divideURLCategories($u_array, $spider_url);

        foreach ($r_array as $link)
        {
                $meta_url = parse_url($spider_url);
                $murl = explode(".", $meta_url["host"]);

                $pattern = "~^http://\w+\.".$murl[count($murl)-2]."\.".$murl[count($murl)-1].".*~Uis";

                if (preg_match($pattern, $link))
                {
                   if (!in_array($link, $master_url_array))
                   {
                      $master_url_array[] = $link;
                   }
                }
        }
}

// check for the difference in length between the keyword array and content link array

if (count($keyword_array) > count($master_url_array))
{
   $diff = intval(count($keyword_array) - count($master_url_array));
   
   for ($i=0; $i<$diff; $i++)
   {
       array_push($master_url_array, $master_url_array[$i]);
   }
}
else if (count($keyword_array) < count($master_url_array))
{
   $diff = intval(count($master_url_array) - count($keyword_array));

   for ($i=0; $i<$diff; $i++)
   {
       array_push($keyword_array, $keyword_array[$i]);
   }
}
else if (count($keyword_array) == count($master_url_array))
{
   continue;
}


$content_length = 500;

// Do the content ripping

foreach ($master_url_array as $index=>$link)
{
        $page_content = getURLContents($link);

        $rel_content = returnOnlyContent($page_content);

        $words = getWordList($rel_content, 1);

        $final_content = returnFinalContent($words, $stopwords, $content_length);

        $entry_datetime = date('Y-m-d').'T'.date('H:i:s').'Z';
        
        $entry_content = str_replace("<br>", "<br />", $final_content);
        $entry_content = str_replace("&nbsp;", " ", $entry_content);
        echo "Entry content is $link<p>";
        $res_code = postToBlogger($blog_id, $blog_username, $blog_password, $blog_url, $keyword_array[$index], $entry_datetime, trim($entry_content));
}


?>


<html>
<head>

<body>

<div><b>Blogger Tool Results</b></div><br /><br />

The content retrieved from the specified URL has been posted to the <br />
blog specified in the form. <br /><br />

Thank you for using this tool. <br /><br />

</body>

</html>
